------------------------------------------------------------------------------------
-- Reset technologies so that vehicle keys are available if mod is loaded into an
-- existing game where the unlock technologies have already been researched.

local GCKI = require('__GCKI__.common')('GCKI')
local script_name = "00-17-04_check_tech.lua"
GCKI.dprint("Entered migration script " .. script_name .. ".")


local technologies = {
    -- Vanilla
    "automobilism",
    -- Cargo Ships
    "water_transport",
}

for _, force in pairs(game.forces) do
    for _, tech in ipairs(technologies) do
        if force.technologies[tech] ~= nil and force.technologies[tech].researched then
            force.technologies[tech].researched = false
            force.technologies[tech].researched = true
        GCKI.dprint("Technology " .. tech .. " reset for force " .. force.name .. "!")
        end
    end
end
GCKI.dprint("End of migration script " .. script_name .. ".")
