------------------------------------------------------------------------------------
-- Autodrive inserts a passenger in vehicles it controls, if necessary (for opening
-- gates and shooting). Locking a vehicle with the keys from GCKI will eject every-
-- body in it, so each time a vehicle in auto-drive mode was locked, a new character
-- for the autodrive-passenger would appear on the map. This has been fixed now, so
-- we better remove any of these useless characters from the game!

local GCKI = require('__GCKI__.common')('GCKI')
local script_name = "00-17-10_remove_autodrive-passenger.lua"

GCKI.dprint("Entered migration script " .. script_name .. ".")

    for name, surface in pairs(game.surfaces) do
        GCKI.dprint("Looking for dummy passenger characters from \"Autodrive\" on surface "
                        .. surface.name .. ":" )
        for index, character in pairs(surface.find_entities_filtered{name = "autodrive-passenger"}) do
            local name = character.name
            character.destroy()
            GCKI.dprint("\tRemoved " .. name .. " (" .. tostring(index) .. ")")
        end
        GCKI.dprint("Done.")
    end

------------------------------------------------------------------------------------
-- Use the opportunity to remove some unused variables from the global table
    for _, var in ipairs({"surface", "position", "carname"}) do
        if global[var] then
            global[var] = nil
            GCKI.dprint("Removed unused variable \"global." .. var .. "\" from saved game.")
        end
    end

GCKI.dprint("End of migration script " .. script_name .. ".")
